from flask import request, Response
import main

def receive():
    body = request.json
    if isBlockchainTraceValid(body):
        message = {'type': 'blockchain-transaction', 'content': body}
        main.message_sender.send('inhub', message, 'trace-retrieval')

    return Response(status=201)

def isBlockchainTraceValid(trace) -> bool:
    return 'TransactionId' in trace \
        and 'Timestamp' in trace \
        and 'ApplicationType' in trace \
        and 'TransactionFrom' in trace \
        and 'TransactionFromLatLng' in trace \
        and 'TransactionTo' in trace \
        and 'TransactionToLatLng' in trace \
        and 'TransferredAsset' in trace \
        and 'ResourceIds' in trace \
        and 'ResourceMd5' in trace \
        and 'ResourceState' in trace \
        and 'Metadata' in trace


